<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of class-lsd-default-skin
 *
 */
class LSD_Default_Skin {

    public $editor;
    public $lsd_metas;

    public function __construct($editor_obj, $lsd_metas) {
        if ($editor_obj) {
            $this->editor = $editor_obj;
            $this->lsd_metas = $lsd_metas;
        }
    }

    /*
     * Header block
     */

    public function lsd_get_editor_header() {
        ob_start();
        ?>
        <a href="#" data-slide-index="<?php echo esc_attr__('0', 'lsd'); ?>" class="lsd-tool-header" >
            <span class="ti-text lsd-tool-icon "></span>
            <span class="lsd-tool-title"><?php echo esc_html__('1. Enter your text', 'lsd'); ?></span>
        </a>
        <a href="#" data-slide-index="<?php echo esc_attr__('1', 'lsd'); ?>" class="lsd-tool-header" >
            <span class="ti-palette lsd-tool-icon"></span>
            <span class="lsd-tool-title"><?php echo esc_html__('2. Style your text', 'lsd'); ?></span>
        </a>
        <a href="#" data-slide-index="<?php echo esc_attr__('2', 'lsd'); ?>" class="lsd-tool-header" >
            <span class="ti-shopping-cart lsd-tool-icon"></span>
            <span class="lsd-tool-title"><?php echo esc_html__('3. Add to cart', 'lsd'); ?></span>
        </a>
        <?php
        echo ob_get_clean();
    }

    /*
     * Text block
     */

    public function lsd_get_text_block($hide_preview_btn="") {
        $config_metas = $this->lsd_metas;
        $show_style = get_proper_value($config_metas, 'enable-style', 'yes');
        $enable_spacing = get_proper_value($config_metas, 'enable-spacing', 'yes');
        $spacing_max = get_proper_value($config_metas, 'spacing-max', 30);
        $enable_alignment = get_proper_value($config_metas, 'enable-alignment', 'yes');
        $enable_reverse = get_proper_value($config_metas, 'enable-reverse', 'yes');
        ?>
        <div class="lsd-row">
            <input type="text" class="lsd-textarea" autocomplete="off"  autocorrect="off" autocapitalize="off" spellcheck="false" value="<?php echo esc_html__('Your text', 'lsd'); ?>" >


        </div>
        <?php if ($enable_alignment === 'yes') { ?>
            <div class="lsd-row">
                <div class="lsd-col left-col">
                    <span><?php echo esc_html__('Text alignment', 'lsd'); ?><span>
                            </div>
                            <div class="lsd-col right-col">
                                <input type="hidden" data-alignment="left" id="lsd-text-alignment" readonly>
                                <span class="lsd-alignments ti-align-left"></span>
                                <span class="lsd-alignments ti-align-center"></span>
                                <span class="lsd-alignments ti-align-right"></span>
                            </div>
                            </div>
                        <?php } ?>   

            <?php if ($show_style === 'yes') { ?>
            <div class="lsd-row">
                <div class="lsd-col left-col">
                    <span><?php echo esc_html__('Text style', 'lsd'); ?><span>
                            </div>
                            <div class="lsd-col right-col">
                                <input type="hidden" data-style="regular" id="lsd-text-style" readonly>
                                <span class="lsd-styles lsd-regular ti-text"></span>
                                <span class="lsd-styles lsd-bold ti-text"></span>
                                <span class="lsd-styles lsd-italic ti-Italic"></span>
                                <span class="lsd-styles lsd-both ti-Italic"></span>
                            </div>
            </div>
    <?php } ?>

                        <div class="lsd-row">
                            <?php if ($enable_spacing === 'yes') { ?>
                                <div class="lsd-col left-col lsd-hidden-tools">
                                    <span class="lsd-dropdown"><?php echo esc_html__('Character spacing', 'lsd'); ?></span>
                                    <div class="lsd-tools-container">
                                        <div class="lsd-range-slider-container">
                                            <div class="lsd-range-slider">
                                                <span class="ti-minus lsd-range-minus lsd-char-minus"></span>
                                                <input class="lsd-range-slider__range" id="lsd-spacing-range" type="range" value="0" min="0" max="<?= $spacing_max ?>" step="1">
                                                <span class="lsd-range-slider-value">1</span>
                                                <span class="ti-plus lsd-range-plus lsd-char-plus"></span>

                                            </div>
                                        </div>
                                    </div>
                                </div>
                            <?php }  ?>
                        </div>

                            <?php if ($enable_reverse === 'yes' || $hide_preview_btn !== 'yes') { ?>
                                <div class="lsd-row">
                                    <?php
                                        if($enable_reverse === 'yes'){
                                            ?>
                                            <div class="lsd-col left-col">
                                                <input id="lsd-reverse-cut" type="checkbox" name="reverse-cut" value="" class="lsd-checkbox"  autocomplete="off">
                                                <label for="lsd-reverse-cut" class="lsd-checkbox-label"><?php echo esc_html__('Reverse cut', 'lsd'); ?></label>
                                                <span class="lsd-what-is-this" data-placement="top" data-tooltip-title="<?php echo esc_html__("We'll cut your lettering backwards so that it can be read normally from outside the window.", 'lsd') ?>" >?</span>
                                            </div>
                                    <?php
                                        }
                                    
                                        if($hide_preview_btn !== 'yes'){
                                            ?>
                                                <div class="lsd-col right-col">
                                                    <button id="lsd-update-preview" class="lsd-button"><?php echo esc_html__('Update preview', 'lsd'); ?></button>
                                                </div>
                                            <?php
                                        }
                                    ?>
                                    
                                </div>
                            <?php } ?>

                        <?php
                    }

                    /*
                     * Style block
                     */

                    public function lsd_get_editor_style_block($hide_preview_btn="") {
                        $config_metas = $this->lsd_metas;
                        $use_global_fonts = get_proper_value($config_metas, 'global-fonts', 'yes');
                        $default_width = get_proper_value($config_metas, 'canvas-w', 144);
                        $default_height = get_proper_value($config_metas, 'canvas-h', 30);

                        $dimensions_type = get_proper_value($config_metas, 'dimensions-type', 'canvas-dimensions');
                        
                        $min_size = get_proper_value($config_metas, 'min-size', 12);
                        $max_size = get_proper_value($config_metas, 'max-size', 60);


                        $enable_shadow = get_proper_value($config_metas, 'enable-shadow', 'no');
                        $shadow_max = get_proper_value($config_metas, 'shadow-max', 10);

                        $enable_outline = get_proper_value($config_metas, 'enable-outline', 'no');
                        $outline_max = get_proper_value($config_metas, 'outline-max', 10);

                        if ('canvas-dimensions' === $dimensions_type) {
                            $dimension_unit = get_proper_value($config_metas, 'canvas-dimensions-unit', 'mm');
                        } else {
                            $dimension_unit = get_proper_value($config_metas, 'font-dimensions-unit', 'mm');
                        }

                        if ('yes' === $use_global_fonts) {
                            $fonts = lsd_add_ttfurl_to_font_array(get_option('lsd-fonts'));
                        } else {
                            $selected_fonts = get_proper_value($config_metas, 'selected-fonts', 'yes');
                            $fonts = lsd_retrieve_fonts_data($selected_fonts);
                        }
                        ?>
                        <div class="lsd-row lsd-preview-font-wrap">
                            <div class="lsd-col left-col lsd-col-25">
                                <span><?php echo esc_html__('Font', 'lsd'); ?></span>
                                <!--span id="lsd-preview-block" class="lsd-button ti-eye"></span-->
                            </div>
                            <div class="lsd-col right-col lsd-col-75">
                                <div class="lsd-font-picker">
                                    <div id="lsd-font-input-cover"></div>
                                    <input type="text" name="font" value=""  data-fonturl="" data-boldfonturl="" data-bothfonturl="" data-italicfonturl="" class="lsd-text-input" id="lsd-font-input" readonly>
                                    <ul class="hidden"  style="overflow:scroll; height:200px;">
                                        <?php
                                        if (!empty($fonts)) {
                                            foreach ($fonts as $font) {
                                                $ttf = '';
                                                if (isset($font['ttf'][0])) {
                                                    $ttf = $font['ttf'][0];
                                                }
                                                $bold = lsd_get_font_styles($font[1], "bold");
                                                $italic = lsd_get_font_styles($font[1], "italic");
                                                $both = lsd_get_font_styles($font[1], "bold-italic");
                                                
                                                echo "<li style='font-family:" . esc_attr($font[0]) . ";' data-fontname='" . esc_attr($font[0]) . "' data-ttf='" . esc_url($ttf) . "' data-fonturl='" . esc_attr($font[1]) . "' data-boldfonturl='" . esc_attr($bold) . "' data-italicfonturl='" . esc_attr($italic) . "' data-bothfonturl='" . esc_attr($both) . "'  >" . esc_attr($font[0]) . '</li>';
                                            }
                                        }
                                        ?>
                                    </ul>
                                </div>	

                                <div id="lsd-font-color-picker" class="lsd-color-picker" data-tooltip-content=".lsd-color-palette.font">
                                    <div class="lsd-color" id="lsd-text-color"></div>
                                    <input type="hidden" name="font-color" value="" data-color="" id="lsd-font-color" readonly>
                                    <div class="lsd-color-palette-container">
                                        <div class="lsd-color-palette font">
                                            <div class="lsd-color-palette-content"></div>
                                        </div>
                                    </div>
                                </div>
                                <span id="lsd-preview-block"><a class="lsd-button" data-toggle="o-modal" data-target="#test"><?php echo __("Preview all fonts","lsd");?></a></span>
                            </div>



                            <div class="omodal fade o-modal lsd-modal lsd_part" id="test" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
                                <div class="omodal-dialog">
                                    <div class="omodal-content">
                                        <div class="omodal-header">
                                            <button id="close" type="button" class="close" data-dismiss="omodal" aria-hidden="true">&times;</button>
                                            <h4 class="omodal-title"><?php echo __("List Preview","lsd");?></h4>
                                        </div>
                                        <div class="omodal-body txt-center">
                                            <div id="lsd-preview-block-content"></div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                        </div>							



                        <div id="lsd-canvas-color-block" class="lsd-row">
                            <div class="lsd-col left-col">
                                <span><?php echo esc_html__('Background color', 'lsd'); ?></span>
                            </div>
                            <div class="lsd-col right-col">
                                <div id="lsd-canvas-color-picker" class="lsd-color-picker" data-tooltip-content=".lsd-color-palette.canvas">
                                    <div class="lsd-color" id="lsd-canvas-bg"></div>
                                    <input type="hidden" name="canvas-color" value="" data-color="" id="lsd-canvas-color" readonly>
                                    <div class="lsd-color-palette-container">
                                        <div class="lsd-color-palette canvas">
                                            <div class="lsd-color-palette-content"></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

        <?php if ($dimensions_type === "font-size") { ?>
                            <div class="lsd-row">
                                <div class="lsd-row">
                                    <div class="lsd-col left-col">
                                        <span><?php echo esc_html__('Font size', 'lsd'); ?></span>
                                        <span class="lsd-what-is-this" data-placement="top" data-tooltip-title="<?php echo esc_html__("Enter the desired font size.", "lsd")?>" >?</span>
                                    </div>
                                    <div class="lsd-col right-col">
                                        <input type="number" name="lsd-font-size" id="lsd-font-size" value="<?php echo esc_attr($min_size); ?>" min="<?php echo esc_attr($min_size); ?>" max="<?php echo esc_attr($max_size); ?>" class="lsd-text-input size-input"  autocomplete="off"  autocorrect="off" autocapitalize="off" spellcheck="false">
            <?= $dimension_unit; ?>    
                                    </div>
                                    <input type="hidden" name="canvas-custom-width" id="canvas-custom-width" value="">
                                    <input type="hidden" name="canvas-custom-height" id="canvas-custom-height" value="">
                                </div>
                            </div>
        <?php } else { ?>
                            <div class="lsd-row">
                                <div class="lsd-row">
                                    <div class="lsd-col left-col">
                                        <span><?php echo esc_html__('Canvas size', 'lsd'); ?></span>
                                        <span class="lsd-what-is-this" data-placement="top" data-tooltip-title="<?php echo esc_html__("Enter requested height or width and press UPDATE SIZE button. The other dimension will be calculated proportionaly.", "lsd") ?>">?</span>
                                    </div>
                                    <div class="lsd-col right-col">
                                        <input type="text" name="canvas-custom-width" id="canvas-custom-width" value="<?php echo esc_attr($default_width); ?>" class="lsd-text-input size-input"  autocomplete="off"  autocorrect="off" autocapitalize="off" spellcheck="false">
                                        <span>X</span>
                                        <input type="text" name="canvas-custom-height" id="canvas-custom-height" value="<?php echo esc_attr($default_height); ?>" class="lsd-text-input size-input" autocomplete="off"  autocorrect="off" autocapitalize="off" spellcheck="false">
                                    </div>
                                    <input type="hidden" name="lsd-font-size" id="lsd-font-size" value="">
                                </div>
                                <div class="lsd-row">
                                    <div class="lsd-col right-col w100">
                                        <span><?php echo esc_html__('(width x height) ', 'lsd'); ?><?= $dimension_unit; ?>  </span>
                                    </div>
                                </div>
                            </div>
                        <?php } ?>
                        <?php
                        if ($enable_shadow === 'yes' || $enable_outline === 'yes' || $hide_preview_btn !== 'yes') {
                            ?>
                            <div class="lsd-row ">
                                <?php
                                    if($enable_shadow === 'yes' || $enable_outline === 'yes'){
                                       ?>
                                         <div class="lsd-col left-col lsd-hidden-tools">
                                            <span class="lsd-dropdown"><?php echo esc_html__('Text effects', 'lsd'); ?></span>
                                            <div class="lsd-tools-container lsd-bottom">

                                                <?php if ($enable_shadow === "yes") { ?>
                                                    <div class="lsd-row">
                                                        <div class="lsd-col left-col">
                                                            <span><?php echo esc_html__('Shadow', 'lsd'); ?></span>
                                                            <span class="lsd-what-is-this" data-placement="top" data-tooltip-title="<?php echo esc_html__("This functionnality let you add a shadow to your text.", "lsd") ?>" >?</span>
                                                        </div>
                                                    </div>
                                                    <div class="lsd-row lsd-mg-bt-20">
                                                        <div class="lsd-col left-col lsd-col-75">
                                                            <div class="lsd-range-slider-container">
                                                                <div class="lsd-range-slider lsd-shadow-slider">
                                                                    <span class="ti-minus lsd-range-minus lsd-shadow-minus"></span>
                                                                    <input class="lsd-range-slider__range lsd-shadow-slider__range" id="lsd-shadow-range" type="range" value="0" min="0" max="<?= $shadow_max ?>" step="1">
                                                                    <span class="lsd-range-slider-value">0</span>
                                                                    <span class="ti-plus lsd-range-plus lsd-shadow-plus"></span>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="lsd-col right-col lsd-col-25">
                                                            <div id="lsd-shadow-color-picker" class="lsd-color-picker" data-tooltip-content=".lsd-color-palette.shadow">
                                                                <div class="lsd-color" id="lsd-text-shadow-color"></div>
                                                                <input type="hidden" name="shadow-color" value="" data-color="" id="lsd-shadow-color" readonly>
                                                                <div class="lsd-color-palette-container">
                                                                    <div class="lsd-color-palette shadow">
                                                                        <div class="lsd-color-palette-content"></div>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>

                                                <?php } ?>

                                                    <?php if ($enable_outline === "yes") { ?>
                                                    <div class="lsd-row">
                                                        <div class="lsd-col left-col">
                                                            <span><?php echo esc_html__('Outline', 'lsd'); ?></span>
                                                            <span class="lsd-what-is-this" data-placement="top" data-tooltip-title="<?php echo esc_html__("This functionnality let you add an outline to your text.", "lsd") ?>" >?</span>
                                                        </div>
                                                    </div> 
                                                    <div class="lsd-row">
                                                        <div class="lsd-col left-col lsd-col-75">
                                                            <div class="lsd-range-slider-container">
                                                                <div class="lsd-range-slider lsd-outline-slider">
                                                                    <span class="ti-minus lsd-range-minus lsd-shadow-minus"></span>
                                                                    <input class="lsd-range-slider__range lsd-outline-slider__range" id="lsd-outline-range" type="range" value="0" min="0" max="<?= $outline_max ?>" step="1">
                                                                    <span class="lsd-range-slider-value">0</span>
                                                                    <span class="ti-plus lsd-range-plus lsd-outline-plus"></span>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="lsd-col right-col lsd-col-25">
                                                            <div id="lsd-outline-color-picker" class="lsd-color-picker" data-tooltip-content=".lsd-color-palette.outline">
                                                                <div class="lsd-color" id="lsd-text-outline-color"></div>
                                                                <input type="hidden" name="outline-color" value="" data-color="" id="lsd-outline-color" readonly>
                                                                <div class="lsd-color-palette-container">
                                                                    <div class="lsd-color-palette outline">
                                                                        <div class="lsd-color-palette-content"></div>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>

                    <?php } ?>

                                            </div>
                                        </div>   
                                       <?php
                                    }
                                    if($hide_preview_btn !== 'yes'){
                                        ?>
                                            <div class="lsd-col right-col">
                                                <button id="update-canvas-size" class="lsd-button"><?php echo esc_html__('Update', 'lsd'); ?></button>
                                            </div>
                                        <?php
                                    }
                                ?>
                                
                            </div>
                            <?php
                        }
                        
                    }

                                    /*
                                     * Action block
                                     */

                                    public function lsd_get_editor_action_block() {
                        ?>
                        <div class="lsd-row">
                            <div class="lsd-col left-col w40">
                                <span><?php echo esc_html__('Quantity', 'lsd'); ?><span>
                                        </div>
                                        <div class="lsd-col w60">
                                            <div class="lsd-quantity-container">
                                                <span class="ti-minus lsd-qty-minus"></span>
                                                <input class="lsd-quantity-field" name="quantity" type="number" value="1" min="1" step="1" autocomplete="off"  autocorrect="off" autocapitalize="off" spellcheck="false">
                                                <span class="ti-plus lsd-qty-plus"></span>
                                            </div>
                                        </div>
                                        </div>
                                        <div class="lsd-row">
                                            <div class="lsd-price-title"><?php echo esc_html__('Price', 'lsd'); ?></div>
                                            <div class="lsd-price-container" id="lsd-price">
                                            </div>
                                        </div>
                                        <div class="lsd-row lsd-last-row">
                                            <button id="lsd-add-to-cart" data-id="<?php echo esc_attr($this->editor->item_id); ?>" class="lsd-button"><?php echo esc_html__('Add to cart', 'lsd') ?></button>
                                        </div>
                                        <?php
                                    }

                                    /*
                                     * Editing area block
                                     */

                                    public function lsd_get_editing_area() {
                                        $config_metas = $this->lsd_metas;
                                        $canvas_w = get_proper_value($config_metas, 'canvas-w', 144);
                                        $canvas_h = get_proper_value($config_metas, 'canvas-h', 30);
                                        $canvas_dimensions_unit = get_proper_value($config_metas, 'canvas-dimensions-unit', 'mm');
                                        $dimensions_type = get_proper_value($config_metas, 'dimensions-type', 'canvas-dimensions');
                                        $show_baseline = get_proper_value($config_metas, 'show-baseline', 'yes');
                                        ?>
                                        <div id="lsd-canvas-width">
                                            <span class="size-w"> <?php echo esc_attr($canvas_w . $canvas_dimensions_unit); ?> </span>
                                        </div>

                                        <div id="lsd-canvas-height">
                                            <span class="size-h"><?php echo esc_attr($canvas_h . $canvas_dimensions_unit); ?></span>
                                        </div>

                                        <?php if ('canvas-dimensions' !== $dimensions_type && 'yes' === $show_baseline) { ?>
                                        <div id="lsd-baseline-height">
                                            <span class="baseline-h"></span>
                                        </div> 
                                        <?php } ?>

                                        <div id="lsd-editor"></div>
                                        <?php
                                    }

                                    /*
                                     * footer block
                                     */

                                    public function lsd_get_editor_footer($editor_notice) {
                                        ?>
                                        <div class="lsd-row">
                                            <div class="lsd-col left-col w80">
                                                <span class="lsd-footer-text">
                                                    <?php echo $editor_notice; ?>
                                                </span>
                                            </div>


                                        </div>
                                        <?php
                                    }

                                    /*
                                     * Main function that handles the full display
                                     */

                                    public function lsd_display() {
                                        global $lsd_settings;
                                        $lsd_settings = apply_filters('lsd_global_settings', $lsd_settings);
                                        $general_options = $lsd_settings['lsd-general-options'];
                                        if (isset($general_options['lsd-hide-preview-button']) && !empty($general_options['lsd-hide-preview-button'])) {
                                            $hide_preview_btn = $general_options['lsd-hide-preview-button'];
                                        } else {
                                            $hide_preview_btn = "yes";
                                        }
                                        
                                        $hide_editor_notice = get_proper_value($general_options, 'lsd-hide-editor-notice' , 'no');
                                        
                                        if(isset($general_options['lsd-editor-notice'])){
                                            $editor_notice = $general_options['lsd-editor-notice'];
                                        }else{
                                           $editor_notice = esc_html__("Please note: The surface colour is for illustrative purposes only and won't be produced. Self-adhesive vinyl letters are individually cut and come pre-spaced with application tape applied.", 'lsd'); 
                                        }
                                        
                                        
                                        ob_start();
                                        $this->register_styles();
                                        $this->register_scripts();
                                        ?>

                                                <div class='lsd-container o-wrap '>
                                                    <!--editor header-->
                                                    <div id="lsd-header">
                                                        <?php
                                                        $this->lsd_get_editor_header();
                                                        ?>
                                                    </div>

                                                    <!--tool boxes-->
                                                    <div id="lsd-tools-container">

                                                        <!--text block -->
                                                        <div class="lsd-tool-block">
                                                            <?php $this->lsd_get_text_block($hide_preview_btn); ?>
                                                        </div>

                                                        <!--style block -->
                                                        <div class="lsd-tool-block">
                                                            <?php $this->lsd_get_editor_style_block($hide_preview_btn); ?>
                                                        </div>

                                                        <!--cart block -->
                                                        <div class="lsd-tool-block">
                                                            <?php $this->lsd_get_editor_action_block(); ?>
                                                        </div>

                                                    </div>
                                                    <!--debug area-->
                                                    <div id="lsd-admin-debug"></div>
                                                    <div id="lsd-debug"></div>
                                                    <!--editing area-->
                                                    <div id="lsd-editing-area">
        <?php $this->lsd_get_editing_area(); ?>
                                                    </div>


                                                    <!--footer block -->
                                                    <?php if('no' === $hide_editor_notice){
                                                        ?>
                                                           <div id="lsd-footer">
                                                                <?php $this->lsd_get_editor_footer($editor_notice); ?>
                                                            </div> 
                                                        <?php
                                                    }?>
                                                    
                                                </div>
        <?php
        $output = ob_get_clean();
        return $output;
    }

    /*
     * Register scripts
     */

    private function register_scripts() {
        wp_enqueue_script('lsd-editor-js', LSD_URL . 'public/js/editor.js', array('jquery'), LSD_VERSION, false);
        wp_enqueue_script('lsdd-accounting-js', LSD_URL . 'public/js/accounting.min.js', array('jquery'), LSD_VERSION, false);
        wp_enqueue_script('lsd-block-UI-js', LSD_URL . 'public/js/blockUI/jquery.blockUI.min.js', array('jquery'), LSD_VERSION, false);

        lsd_register_scripts();
    }

    /*
     * Register styles files
     */

    private function register_styles() {
        lsd_register_fonts($this->lsd_metas);
    }

}
