var LSD_EDITOR = (function ($, lsd_editor) {
    'use strict';
    var lsd_editor = {};
    lsd_editor.canvas = {};

    $(document).ready(function () {

        setTimeout(function () {
            $("#lsd-admin-debug").html("");
            lsd_retrieve_built_image();
        }, 10);

        if (typeof lsd != 'undefined')
        {
            accounting.settings = {
                currency: {
                    symbol: lsd.currency, // default currency symbol is '$'
                    format: lsd.price_format, // controls output: %s = symbol, %v = value/number (can be object: see below)
                    decimal: lsd.decimal_sep, // decimal point separator
                    thousand: lsd.thousand_sep, // thousands separator
                    precision: lsd.nb_decimals   // decimal places
                },
                number: {
                    precision: lsd.nb_decimals, // default precision on numbers is 0
                    thousand: lsd.thousand_sep,
                    decimal: lsd.decimal_sep
                }
            }
        }

        // if (typeof additionnal_rules != 'undefined') {
        //   $.each(additionnal_rules,function (key,rule) {
        //     var verify_result = lsd_verify_condition(rule.rules);
        //     if (verify_result) {
        //       additionnal_price = additionnal_price + parseInt(rule.a_price);
        //     }
        //   });
        // }

        //disable context menu for image
        $("#lsd-editing-area").bind("contextmenu", function (e) {
            return false;
        });

        /*
         * function to update the price (input and span)
         */

        function lsd_update_price() {
            var additionnal_rules = lsd.pricing_rules;
            var basing_price = parseFloat(lsd.product_price);
            var text_palette_tpl_price = lsd.text_palette_tpl_pricing;
            var bg_palette_tpl_price = lsd.bg_palette_tpl_pricing;
            var shadow_palette_tpl_price = lsd.shadow_palette_tpl_pricing;
            var outline_palette_tpl_price = lsd.outline_palette_tpl_pricing;
            var text_color_price = 0;
            var bg_color_price = 0;
            var shadow_color_price = 0;
            var outline_color_price = 0;
            var additionnal_price_per_item = 0;
            var additionnal_price_on_design = 0;

            //retrieve text color
            if($('#lsd-font-color').lenght){
            var text_color = $('#lsd-font-color').attr("data-color").toUpperCase();
            if (typeof text_palette_tpl_price !== 'undefined') {
                $.each(text_palette_tpl_price, function (index, text) {
                    if (text.hex.toUpperCase() === text_color || text.name.toUpperCase() === text_color) {
                        if ($.isNumeric(parseFloat(text.price))) {
                            text_color_price = parseFloat(text.price);
                        }
                    }
                });
            }}

            //retrieve canvas color
            if($('#lsd-canvas-color').lenght){
            var canvas_color = $('#lsd-canvas-color').attr("data-color").toUpperCase();
            if (typeof bg_palette_tpl_price !== 'undefined') {
                $.each(bg_palette_tpl_price, function (index, bg) {
                    if (bg.hex.toUpperCase() === canvas_color || bg.name.toUpperCase() === canvas_color) {
                        if ($.isNumeric(parseFloat(bg.price))) {
                            bg_color_price = parseFloat(bg.price);
                        }
                    }
                });
            }
        }
            
            //retrieve shadow color
            if($('#lsd-shadow-color').lenght){
                var shadow_color = $('#lsd-shadow-color').attr("data-color").toUpperCase();
                var shadow_val = $('#lsd-shadow-range').val();
                if (typeof shadow_palette_tpl_price !== 'undefined') {
                    $.each(shadow_palette_tpl_price, function (index, shadow) {
                        if (shadow.hex.toUpperCase() === shadow_color || shadow.name.toUpperCase() === shadow_color && parseInt(shadow_val) > 0) {
                            if ($.isNumeric(parseFloat(shadow.price))) {
                                shadow_color_price = parseFloat(shadow.price);
                            }
                        }
                    });
                }
            }
            
            
            //retrieve outline color
            if($('#lsd-outline-color').lenght){
                var outline_color = $('#lsd-outline-color').attr("data-color").toUpperCase();
                var outline_val = $('#lsd-outline-range').val();
                if (typeof outline_palette_tpl_price !== 'undefined') {
                    $.each(outline_palette_tpl_price, function (index, outline) {
                        if (outline.hex.toUpperCase() === outline_color || outline.name.toUpperCase() === outline_color && parseInt(outline_val) > 0) {
                            if ($.isNumeric(parseFloat(outline.price))) {
                                outline_color_price = parseFloat(outline.price);
                            }
                        }
                    });
                }
            }

            if (typeof additionnal_rules !== 'undefined') {
                $.each(additionnal_rules, function (key, rule) {
                    var verify_result = lsd_verify_condition(rule);
                    if (verify_result) {
                        if (verify_result.verify) {
                            additionnal_price_per_item = additionnal_price_per_item + parseFloat(verify_result.additionnal_price);
                            if ($.isNumeric(parseFloat(rule.a_price))) {
                                if (rule.scope === 'design') {
                                    additionnal_price_on_design = additionnal_price_on_design + parseFloat(rule.a_price);
                                }
                            }
                        }
                    }
                });
            }
            var qty = parseInt($(".lsd-quantity-field").val());
            var total = (parseFloat(basing_price) + parseFloat(text_color_price) + parseFloat(bg_color_price)  + parseFloat(shadow_color_price)  + parseFloat(outline_color_price) + parseFloat(additionnal_price_per_item) + parseFloat(additionnal_price_on_design)) * parseInt(qty);
            $("#lsd-price").html(accounting.formatMoney(total));
        }

        function lsd_verify_condition(rule) {
            if (typeof rule != 'undefined') {
                var comparaison_result = [];
                $.each(rule.rules, function (index, this_rule) {
                    if (typeof this_rule != 'undefined' && this_rule.param != 'undefined') {
                        //retrieve the text in the textarea
                        var enteredText = $('.lsd-textarea').val();
                        var formattedText = enteredText.replace(/\n/g, '<br/>');
                        switch (this_rule.param) {
                            case "txt_nb_chars":
                                if (typeof formattedText != 'undefined') {
                                    var text_size = formattedText.length;
                                    comparaison_result.push(lsd_operator(this_rule.operator, text_size, this_rule.value));
                                }
                                break;
                            case "txt_nb_lines":
                                if (typeof formattedText != 'undefined') {
                                    var text_nb_line = formattedText.split("<br/>").length;
                                    comparaison_result.push(lsd_operator(this_rule.operator, text_nb_line, this_rule.value));
                                }
                                break;
                            case "if_canvas_square_unit":
                                var canvas_w = parseInt($('#canvas-custom-width').val());
                                var canvas_h = parseInt($('#canvas-custom-height').val());
                                if (typeof canvas_w != 'undefined' && typeof canvas_h != 'undefined') {
                                    var canvas_square = canvas_h * canvas_w;
                                    comparaison_result.push(lsd_operator(this_rule.operator, canvas_square, this_rule.value));
                                }
                                break;
                            case "if_selected_font":
                                //retrieve the selected font
                                rule.scope = 'design';
                                var font = $('#lsd-font-input').val();
                                if (typeof font != 'undefined') {
                                    comparaison_result.push(lsd_operator(this_rule.operator, font, this_rule.value));
                                }
                                break;
                            case "if_char_spacing":
                                //letter spacing
                                var space = parseInt($("#lsd-spacing-range").val());
                                if (typeof space != 'undefined') {
                                    comparaison_result.push(lsd_operator(this_rule.operator, space, this_rule.value));
                                }
                                break;
                            default:
                                comparaison_result = comparaison_result;
                                break;
                        }
                    }
                });
                var verify = 0;
                $.each(comparaison_result, function (key, value) {
                    if (value.result) {
                        verify++;
                    }
                });
                var additionnal_price_per_item = 0;
                var result = [];
                result['verify'] = false;

                if (verify === comparaison_result.length) {
                    result['verify'] = true;
                    $.each(comparaison_result, function (key, value) {
                        if (rule.scope === 'item' && typeof (value.remaining_number) != 'undefined') {
                            additionnal_price_per_item = additionnal_price_per_item + (value.remaining_number * rule.a_price);
                        } else {
                            additionnal_price_per_item = additionnal_price_per_item + 0;
                        }
                    });
                    result['additionnal_price'] = additionnal_price_per_item;
                }
                return result;
            }
        }

        function lsd_operator(operator, giving_value, rule_value) {
            var data = [];
            if (operator === ">") {
                data['result'] = giving_value > rule_value;
                if (giving_value > rule_value) {
                    data['remaining_number'] = giving_value - rule_value;
                }
                return data;
            } else if (operator === ">=") {
                data['result'] = giving_value >= rule_value;
                if (giving_value >= rule_value) {
                    data['remaining_number'] = (giving_value - rule_value) + 1;
                }
                return data;
            } else if (operator === "<") {
                data['result'] = giving_value < rule_value;
                if (giving_value < rule_value) {
                    data['remaining_number'] = rule_value - giving_value;
                }
                return data;
            } else if (operator === "<=") {
                data['result'] = giving_value <= rule_value;
                if (giving_value < rule_value) {
                    data['remaining_number'] = (rule_value - giving_value) + 1;
                }
                return data;
            } else if (operator === "==") {
                data['result'] = giving_value == rule_value;
                if ($.isNumeric(parseInt(giving_value)) && $.isNumeric(parseInt(rule_value)) && giving_value === rule_value) {
                    data['remaining_number'] = giving_value;
                }
                return data;
            } else {
                data['result'] = giving_value != rule_value;
                if ($.isNumeric(parseInt(giving_value)) && $.isNumeric(parseInt(rule_value)) && giving_value !== rule_value) {
                    data['remaining_number'] = giving_value;
                }
                return data;
            }
        }

        /*
         * Function to retrieve image from user selection
         */
        function lsd_retrieve_built_image() {
            lsd_update_dimensions();
            $("#lsd-editor").html("");
            var data = lsd_retrieve_designer_data();
            if ('canvas-dimensions' === lsd.dimensions_type && (isNaN(data.width) || isNaN(data.height))) {
                $("#lsd-admin-debug").html("Wrong dimensions given");
                lsd_update_price();
            } else {
                $.blockUI({message: lsd.translated_strings.loading_msg});
                var lsd_generate_design_nonce = $('#lsd_generate_design_nonce').val();
                $.post(
                        lsd_ajax_object.lsd_ajax_url,
                        {
                            action: "lsd_generate_image",
                            cache: false,
                            data: data,
                            lsd_generate_design_nonce: lsd_generate_design_nonce
                        },
                        function (response) {
                            var retrievedData = JSON.parse(response);
                             if (retrievedData.image) {
                                $("#canvas-custom-width").prop('disabled', false);
                                $("#canvas-custom-height").prop('disabled', false);
                                setTimeout(function () {
                                $("#lsd-editor").html("");
                                window.URL.revokeObjectURL(retrievedData.image);
                                $("#lsd-editor").append("<img src='" + retrievedData.image + '?' + Math.random() * Math.random() + "' />");
                                $('#canvas-custom-width').val(retrievedData.width);
                                $('#canvas-custom-height').val(retrievedData.height);
                                $('#lsd-font-size').val(retrievedData.fontsize);
                                $("#canvas-custom-width").attr('value', retrievedData.width);
                                $("#canvas-custom-height").attr('value', retrievedData.height);
                                lsd_update_price();
                                }, 10);

                                //display values in spans
                                $('.size-w').html(retrievedData.width + data.unit);
                                $('.size-h').html(retrievedData.height + data.unit);
                                $('.baseline-h').html(retrievedData.baseline + data.unit);

                                //add propervalues to css
                                var output_dimensions = lsd_calculate_output_dimensions(retrievedData.scaledWidth, retrievedData.scaledHeight, retrievedData.scaledBaseline, data.unit);
                                $("#lsd-canvas-width").css("width", output_dimensions[0]);
                                $("#lsd-canvas-height").css("height", output_dimensions[1]);
                                $("#lsd-baseline-height").css("height", output_dimensions[2]);
                                if (lsd.show_fontsize === 'yes' && 'canvas-dimensions' === lsd.dimensions_type) {
                                    $("#lsd-admin-debug").append("<p> Font size: " + retrievedData.fontsize + "</p>");
                                }
                                $("#lsd-admin-debug").append(retrievedData.message);
                                $.unblockUI();
                             } else {
                                $("#lsd-admin-debug").html(retrievedData.message);
                                lsd_update_price();
                                $.unblockUI();
                             }
                        }
                )
                        .fail(function (response) {
                            $("#lsd-admin-debug").html("").append('the process has failed, please retry it.');
                            $.unblockUI();
                        });
            }
        }

        function lsd_convert_unit_to_px(dimension, unit) {
            switch (unit) {
                case 'mm':
                    dimension = Math.round(dimension * 3.779528);
                    break;
                case 'cm':
                    dimension = Math.round(dimension * 37.79528);
                    break;
                case 'inch':
                    dimension = Math.round(dimension * 96.000000000001);
                    break;
                case 'pt':
                    dimension = Math.round(dimension * 1.3333333333333);
                    break;
                default:
                    break;
            }
            return dimension;
        }

        //calculate output dimensions to fit the available editor's dimensions
        function lsd_calculate_output_dimensions(o_width, o_height, o_baseline, unit) {
            var width = $('#lsd-editor').width();

            o_width = lsd_convert_unit_to_px(o_width, unit);
            o_height = lsd_convert_unit_to_px(o_height, unit);
            o_baseline = lsd_convert_unit_to_px(o_baseline, unit);

            if (width > o_width) {
                width = o_width;
            }
            var height = (o_height * width) / o_width;
            var baseline = (o_baseline * width) / o_width;

            return [width, height, baseline];
        }

        //function to retrieve all data from the designer
        function lsd_retrieve_designer_data() {
            var data = {};
            //retrieve the text in the textarea
            var enteredText = $('.lsd-textarea').val();
            var formattedText = enteredText.replace(/\n/g, '<br/>');
            data["text"] = formattedText;

            //retrieve the selected font
            var font = $('#lsd-font-input').val();
            data["font"] = font;

            //retrieve the selected font url
            var fonturl = $('#lsd-font-input').attr('data-fonturl');
            data["font-url"] = fonturl;

            //retrieve the selected font ttf
            data["font-ttf"] = $('#lsd-font-input').attr('data-ttf');

            var canvas_w = $('#canvas-custom-width').val();
            var canvas_h = $('#canvas-custom-height').val();

            //data['width'] = $("#lsd-editing-area").width();
            //data['height'] = Math.round((canvas_h * data['width']) / canvas_w);

            data['width'] = canvas_w;
            data['height'] = canvas_h;

            data['custom-width'] = canvas_w;
            data['custom-height'] = canvas_h;

            //retrieve text color
            var text_color = $('#lsd-font-color').attr("data-color");
            data['text_color'] = text_color;

            //retrieve canvas color
            var canvas_color = $('#lsd-canvas-color').attr("data-color");
            if (canvas_color === "") {
                canvas_color = 'transparent';
            }
            data['canvas_color'] = canvas_color;

            //retrieve shadow color
            var shadow_color = $('#lsd-shadow-color').attr("data-color");
            data['shadow_color'] = shadow_color;

            //retrieve outline color
            var outline_color = $('#lsd-outline-color').attr("data-color");
            data['outline_color'] = outline_color;

            data['unit'] = lsd.canvas_dimensions_unit;

            //verify if reverse is checked
            if ($('#lsd-reverse-cut').prop('checked')) {
                data['reverse'] = "true";
            } else {
                data['reverse'] = "false";
            }

            //data['ratio'] = lsd.keep_ratio;

            //alignment
            data['alignment'] = $('#lsd-text-alignment').attr("data-alignment");

            //style
            data['style'] = $('#lsd-text-style').attr("data-style");

            //letter spacing
            data['spacing'] = $("#lsd-spacing-range").val();

            //verify if curved is checked
//            if ($('#lsd-enable-curving').prop('checked')) {
//                data['enable-curving'] = "true";
//            } else {
//                data['enable-curving'] = "false";
//            }

            //text curving
            //data['curving'] = $("#lsd-curving-range").val();

            //text shadow
            data['shadow'] = $("#lsd-shadow-range").val();


            //text outline
            data['outline'] = $("#lsd-outline-range").val();

            //chosen font size
            data['font-size'] = $("#lsd-font-size").val();

            data['dimensions-type'] = lsd.dimensions_type;

            return data;
        }


        /*
         *
         * function to get the optimal dimensions off the canvas
         */
        function get_optimal_dimensions() {
            var canvas_w = $('#canvas-custom-width').val();
            var canvas_h = $('#canvas-custom-height').val();

            if (lsd.keep_ratio === "yes") {
                if (canvas_w === "" && canvas_h !== "") {
                    var ratio = lsd.canvas_w / lsd.canvas_h;
                    canvas_w = Math.ceil(parseFloat(canvas_h) * ratio);

                } else if (canvas_w !== "" && canvas_h === "") {
                    var ratio = lsd.canvas_h / lsd.canvas_w;
                    canvas_h = Math.ceil(parseFloat(canvas_w) * ratio);

                } else {
                    canvas_w = lsd.canvas_w;
                    canvas_h = lsd.canvas_h;
                }
            }

            return [canvas_w, canvas_h];
        }

        /*
         * function to update the dimensions (input and span)
         */
        function lsd_update_dimensions() {
            var data = get_optimal_dimensions();
            var width = parseFloat(data[0]);
            var height = parseFloat(data[1]);
            //retrieve the text in the textarea
            var enteredText = $('.lsd-textarea').val();
            
            if("font-size" !== lsd.dimensions_type){
                $("#lsd-canvas-width").find("span").html(width + lsd.canvas_dimensions_unit);
                $("#lsd-canvas-height").find("span").html(height + lsd.canvas_dimensions_unit);
                $('#canvas-custom-width').val(width);
                $('#canvas-custom-height').val(height);
                $("#canvas-custom-width").attr('value', width);
                $("#canvas-custom-height").attr('value', height);
            }
        }

        /*
         *
         * end of the functions set------------------------------------------------------
         */
        

        /*
         * initialize default values
         */
        
        
        //bold
            if ( $('.lsd-font-picker ul li').first().attr("data-boldfonturl") !== null && $('.lsd-font-picker ul li').first().attr("data-boldfonturl") !== '') {
                $('.lsd-bold').css('display', 'inline-block');
            } else {
                $('.lsd-bold').css('display', 'none');
            }
            
            //italic
            if ( $('.lsd-font-picker ul li').first().attr("data-bothfonturl") !== null && $('.lsd-font-picker ul li').first().attr("data-bothfonturl") !== '') {
                $('.lsd-italic').css('display', 'inline-block');
            } else {
                $('.lsd-italic').css('display', 'none');
            }
            
            //both
            if ( $('.lsd-font-picker ul li').first().attr("data-bothfonturl") !== null && $('.lsd-font-picker ul li').first().attr("data-boldfonturl") !== '') {
                $('.lsd-both').css('display', 'inline-block');
            } else {
                $('.lsd-both').css('display', 'none');
            }

        //font
        $('#lsd-font-input').attr("value", $('.lsd-font-picker ul li').first().text());
        $('#lsd-font-input').attr("data-fonturl", $('.lsd-font-picker ul li').first().attr("data-fonturl"));

        $('#lsd-font-input').attr("data-boldfonturl", $('.lsd-font-picker ul li').first().attr("data-boldfonturl"));
        $('#lsd-font-input').attr("data-italicfonturl", $('.lsd-font-picker ul li').first().attr("data-italicfonturl"));
        $('#lsd-font-input').attr("data-bothfonturl", $('.lsd-font-picker ul li').first().attr("data-bothfonturl"));

        $('#lsd-font-input').attr("data-minwidth", $('.lsd-font-picker ul li').first().attr("data-minwidth"));
        $('#lsd-font-input').attr("data-minheight", $('.lsd-font-picker ul li').first().attr("data-minheight"));
        $('#lsd-font-input').attr("data-ttf", $('.lsd-font-picker ul li').first().attr("data-ttf"));
        $('#lsd-font-input').css("font-family", $('.lsd-font-picker ul li').first().text());

        //text color
        if (lsd.text_palette_type === "colors") {
            $('#lsd-font-color-picker .lsd-color').css('background-color', lsd.text_palette_tpl[0]);
            $('#lsd-font-color').attr("data-color", lsd.text_palette_tpl[0]);
            var default_text_color = lsd.text_palette_tpl[0];
        }else if (lsd.text_palette_type === "colorpicker") {
            $('#lsd-font-color-picker .lsd-color').css('background-color', lsd.text_default_color);
            if (lsd.text_default_color !== '' && lsd.text_default_color !== null) {
                $('#lsd-font-color-picker .lsd-color').css('background-color', lsd.text_default_color);
                $('#lsd-font-color').attr("data-color", lsd.text_default_color);
                var default_text_color = lsd.text_default_color;
            } else {
                $('#lsd-font-color-picker .lsd-color').css('background-color', "#ffffff");
                $('#lsd-font-color').attr("data-color", "#ffffff");
                var default_text_color = "#ffffff";
            }
        }else{}
        
        /*
         * Color picker for text
         */
        //control the stext color setting
        if (lsd.text_palette_type === "colors") {
            var showTextPaletteOnly = true;
            var showTextPalette = true;
        } else {
            var showTextPaletteOnly = false;
            var showTextPalette = false;
        }

        $('#lsd-text-color').spectrum({
            move: function (color) {
                $('#lsd-font-color').attr("data-color", color.toHexString());
                $('#lsd-font-color-picker .lsd-color').css('background-color', color);

            },
            change: function (color) {
                $('#lsd-font-color').attr("data-color", color.toHexString());
                $('#lsd-font-color-picker .lsd-color').css('background-color', color);
                if (lsd.hide_preview === 'yes') {
                    setTimeout(function () {
                        $("#lsd-admin-debug").html("");
                        lsd_retrieve_built_image();
                    }, 100);
                } else {
                    setTimeout(function () {
                        $("#lsd-update-preview").click();
                    }, 300);
                }
            },
            //flat: true,
            preferredFormat: "name",
            showInput: true,
            showAlpha: false,
            showPaletteOnly: showTextPaletteOnly,
            color: default_text_color,
            clickoutFiresChange: true,
            showPalette: showTextPalette,
            palette: lsd.text_palette_tpl,
        });

        /*
         * end ---------------------------------------------------------------------------
         */
        
        //canvas color
        if (lsd.bg_palette_type === "colors") {
            $('#lsd-canvas-color-picker .lsd-color').css('background-color', lsd.bg_palette_tpl[0]);
            $('#lsd-canvas-color').attr("data-color", lsd.bg_palette_tpl[0]);
            var default_bg_color = lsd.bg_palette_tpl[0];
            var showBgPaletteOnly = true;
            var showBgPalette = true;
        }else if (lsd.bg_palette_type === "colorpicker") {
            $('#lsd-canvas-color-picker .lsd-color').css('background-color', lsd.bg_default_color);
            if (lsd.bg_default_color !== '' && lsd.bg_default_color !== null) {
                $('#lsd-canvas-color-picker .lsd-color').css('background-color', lsd.bg_default_color);
                $('#lsd-canvas-color').attr("data-color", lsd.bg_default_color);
                var default_bg_color = lsd.bg_default_color;
            } else {
                $('#lsd-canvas-color-picker .lsd-color').css('background-color', "#000000");
                $('#lsd-canvas-color').attr("data-color", "#000000");
                var default_bg_color = "#000000";
            }
            var showBgPaletteOnly = false;
            var showBgPalette = false;
        }else{
            $("#lsd-canvas-color-block").hide();
        }
        
        /*
         * Color picker for background
         */
        //control the setting choosed for the background color

        $('#lsd-canvas-bg').spectrum({
            move: function (color) {
                $('#lsd-canvas-color-picker .lsd-color').css('background-color', color);
                $('#lsd-canvas-color').attr("data-color", color.toHexString());
            },
            change: function (color) {
                $('#lsd-canvas-color-picker .lsd-color').css('background-color', color);
                $('#lsd-canvas-color').attr("data-color", color.toHexString());
                if (lsd.hide_preview === 'yes') {
                    setTimeout(function () {
                        $("#lsd-admin-debug").html("");
                        lsd_retrieve_built_image();
                    }, 100);
                } else {
                    setTimeout(function () {
                        $("#lsd-update-preview").click();
                    }, 300);
                }
            },
            //flat: true,
            preferredFormat: "name",
            showInput: true,
            showAlpha: false,
            showPaletteOnly: showBgPaletteOnly,
            color: default_bg_color,
            clickoutFiresChange: true,
            showPalette: showBgPalette,
            palette: lsd.bg_palette_tpl,
        });



        /*
         * end ---------------------------------------------------------------------------------
         */

        //shadow color
        if (lsd.shadow_palette_type === "colors") {
            $('#lsd-shadow-color-picker .lsd-color').css('background-color', lsd.shadow_palette_tpl[0]);
            $('#lsd-shadow-color').attr("data-color", lsd.shadow_palette_tpl[0]);
            var default_shadow_color = lsd.shadow_palette_tpl[0];
        }else if (lsd.shadow_palette_type === "colorpicker") {
            if (lsd.shadow_default_color !== '' && lsd.shadow_default_color !== null) {
                $('#lsd-shadow-color-picker .lsd-color').css('background-color', lsd.shadow_default_color);
                $('#lsd-shadow-color').attr("data-color", lsd.shadow_default_color);
                var default_shadow_color = lsd.shadow_default_color;
            } else {
                $('#lsd-shadow-color-picker .lsd-color').css('background-color', "#8a878a");
                $('#lsd-shadow-color').attr("data-color", "#8a878a");
                var default_shadow_color = "#8a878a";
            }

        }else{}

        /*
         * Color picker for shadow
         */
        //control the setting choosed for the text shadow color
        if (lsd.shadow_palette_type === "colors") {
            var showShadowPaletteOnly = true;
            var showShadowPalette = true;
        } else if (lsd.shadow_palette_type === "colorpicker") {
            var showShadowPaletteOnly = false;
            var showShadowPalette = false;
        } else {
            $("#lsd-shadow-color-picker").hide();
        }

        $('#lsd-text-shadow-color').spectrum({
            move: function (color) {
                $('#lsd-shadow-color-picker .lsd-color').css('background-color', color);
                $('#lsd-shadow-color').attr("data-color", color.toHexString());
            },
            change: function (color) {
                $('#lsd-shadow-color-picker .lsd-color').css('background-color', color);
                $('#lsd-shadow-color').attr("data-color", color.toHexString());
                if (lsd.hide_preview === 'yes') {
                    setTimeout(function () {
                        $("#lsd-admin-debug").html("");
                        lsd_retrieve_built_image();
                    }, 100);
                } else {
                    setTimeout(function () {
                        $("#lsd-update-preview").click();
                    }, 100);
                }

            },
            //flat: true,
            preferredFormat: "name",
            showInput: true,
            showAlpha: false,
            showPaletteOnly: showShadowPaletteOnly,
            color: default_shadow_color,
            clickoutFiresChange: true,
            showButtons: true,
            showPalette: showShadowPalette,
            palette: lsd.shadow_palette_tpl,
        });

        /*
         * end ---------------------------------------------------------------------------------
         */

        //outline color
        if (lsd.outline_palette_type === "colors") {
            $('#lsd-outline-color-picker .lsd-color').css('background-color', lsd.outline_palette_tpl[0]);
            $('#lsd-outline-color').attr("data-color", lsd.outline_palette_tpl[0]);
            var default_outline_color = lsd.outline_palette_tpl[0];
        }else if (lsd.outline_palette_type === "colorpicker") {
            if (lsd.outline_default_color !== '' && lsd.outline_default_color !== null) {
                $('#lsd-outline-color-picker .lsd-color').css('background-color', lsd.outline_default_color);
                $('#lsd-outline-color').attr("data-color", lsd.outline_default_color);
                var default_outline_color = lsd.outline_default_color;
            } else {
                $('#lsd-outline-color-picker .lsd-color').css('background-color', "#8a878a");
                $('#lsd-outline-color').attr("data-color", "#8a878a");
                var default_outline_color = "#8a878a";
            }

        }else{}

        /*
         * Color picker for outline
         */
        //control the setting choosed for the text outline color
        if (lsd.outline_palette_type === "colors") {
            var showOutlinePaletteOnly = true;
            var showOutlinePalette = true;
        } else if (lsd.outline_palette_type === "colorpicker") {
            var showOutlinePaletteOnly = false;
            var showOutlinePalette = false;
        } else {
            $("#lsd-outline-color-picker").hide();
        }

        $('#lsd-text-outline-color').spectrum({
            move: function (color) {
                $('#lsd-outline-color-picker .lsd-color').css('background-color', color);
                $('#lsd-outline-color').attr("data-color", color.toHexString());
            },
            change: function (color) {
                $('#lsd-outline-color-picker .lsd-color').css('background-color', color);
                $('#lsd-outline-color').attr("data-color", color.toHexString());
                setTimeout(function () {
                    $("#lsd-update-preview").click();
                }, 300);
            },
            //flat: true,
            preferredFormat: "name",
            showInput: true,
            showAlpha: false,
            showPaletteOnly: showOutlinePaletteOnly,
            color: default_outline_color,
            clickoutFiresChange: true,
            showButtons: true,
            showPalette: showOutlinePalette,
            palette: lsd.outline_palette_tpl,
        });

        /*
         * end ---------------------------------------------------------------------------------
         */

        


        //position the tooltip
        
        if( $('.lsd-color-picker').length > 0 ){
            $('.lsd-color-picker').tooltipster({
                side: 'bottom',
                trigger: 'click',
                interactive: true,
            });
        }


        //check if user is typing in the width box and disable the typing for the height box
        $(document).on("keydown", "#canvas-custom-width", function () {
            if (lsd.keep_ratio === "yes") {
                $("#canvas-custom-height").val("");
                $("#canvas-custom-height").prop('disabled', true);
            }

        });
        //check if user is typing in the width box and disable the typing for the height box
        $(document).on("keydown", "#canvas-custom-height", function () {
            if (lsd.keep_ratio === "yes") {
                $("#canvas-custom-width").val("");
                $("#canvas-custom-width").prop('disabled', true);
            }
        });

        //update preview on check reverse checkbox
        $(document).on("change", "#lsd-reverse-cut, #lsd-spacing-range", function () {
            setTimeout(function () {
                if (lsd.hide_preview === 'yes') {
                    $("#lsd-admin-debug").html("");
                    lsd_retrieve_built_image();
                }
            }, 10);
        });


        //control if entered font size has not reached it limits
        var font_typing_timer;
        var done_typing_interval = 1000;
        var $font_input = $("#lsd-font-size");

        //on keyup, start the countdown
        $font_input.on('keyup', function () {
            clearTimeout(font_typing_timer);
            font_typing_timer = setTimeout(fontDoneTyping, done_typing_interval);
        });

        //on keydown, clear the countdown
        $font_input.on('keydown', function () {
            clearTimeout(font_typing_timer);
        });

        //user is "finished typing," do the checking
        function fontDoneTyping() {
            setTimeout(function () {
                var min = parseInt($("#lsd-font-size").attr("min"));
                var max = parseInt($("#lsd-font-size").attr("max"));
                var value = parseInt($("#lsd-font-size").val());
                if (value < min) {
                    $("#lsd-font-size").val(min);
                    $("#lsd-admin-debug").html("<p>The minimum font size allowed is " + min + " " + lsd.canvas_dimensions_unit + "</p>");
                } else if (value > max) {
                    $("#lsd-font-size").val(max);
                    $("#lsd-admin-debug").html("<p>The maximum font size allowed is " + max + " " + lsd.canvas_dimensions_unit + "</p>");
                } else if (isNaN(value)) {
                    $("#lsd-font-size").val(min);
                    $("#lsd-admin-debug").html("<p>Only numbers are allowed.</p>");
                } else {
                    $("#lsd-admin-debug").html("");
                }
            }, 10);
        }


        $(document).on("click", "#update-canvas-size", function () {
            setTimeout(function () {
                $("#lsd-update-preview").click();
            }, 10);
        });

        //initial dimensions update after dimension has been entered
        var typingTimer;
        var doneTypingInterval = 1000;
        var $input = $("#canvas-custom-width, #canvas-custom-height, #lsd-font-size,.lsd-textarea");

        //on keyup, start the countdown
        $input.on('keyup', function () {
            clearTimeout(typingTimer);
            typingTimer = setTimeout(doneTyping, doneTypingInterval);
        });

        //on keydown, clear the countdown
        $input.on('keydown', function () {
            clearTimeout(typingTimer);
        });

        //on change event
//        $input.on('change', function () {
//            doneTyping();
//        });
        //user is "finished typing," do the checking
        function doneTyping() {
            if (lsd.hide_preview === 'yes') {
                setTimeout(function () {
                    $("#lsd-admin-debug").html("");
                    lsd_retrieve_built_image();
                }, 10);
            }

        }

        //font handling
        var fontList = $('.lsd-font-picker input[type="text"]').next('ul');
        $('#lsd-font-input-cover').on('click', function () {

            if (fontList.hasClass('hidden'))
                fontList.removeClass('hidden');
            else
                fontList.addClass('hidden');
        });


        $(document).mouseup(function (e) {
            var container = $('.lsd-font-picker');
            // if the target of the click isn't the container nor a descendant of the container
            if (!container.is(e.target) && container.has(e.target).length === 0)
            {
                fontList.addClass('hidden');
            }
        });

        $('.lsd-font-picker ul li').on('click', function () {
            //bold
            if ( $(this).attr("data-boldfonturl") !== null && $(this).attr("data-boldfonturl") !== '') {
                $('.lsd-bold').css('display', 'inline-block');
            } else {
                $('.lsd-bold').css('display', 'none');
            }
            
            //italic
            if ( $(this).attr("data-bothfonturl") !== null && $(this).attr("data-bothfonturl") !== '') {
                $('.lsd-italic').css('display', 'inline-block');
            } else {
                $('.lsd-italic').css('display', 'none');
            }
            
            //both
            if ( $(this).attr("data-bothfonturl") !== null && $(this).attr("data-boldfonturl") !== '') {
                $('.lsd-both').css('display', 'inline-block');
            } else {
                $('.lsd-both').css('display', 'none');
            }

            $('#lsd-font-input').attr("value", $(this).text());
            $('#lsd-font-input').attr("data-fonturl", $(this).attr("data-fonturl"));

            $('#lsd-font-input').attr("data-boldfonturl", $(this).attr("data-boldfonturl"));
            $('#lsd-font-input').attr("data-italicfonturl", $(this).attr("data-italicfonturl"));
            $('#lsd-font-input').attr("data-bothfonturl", $(this).attr("data-bothfonturl"));

            $('#lsd-font-input').attr("data-minwidth", $(this).attr("data-minwidth"));
            $('#lsd-font-input').attr("data-minheight", $(this).attr("data-minheight"));
            $('#lsd-font-input').attr("data-ttf", $(this).attr("data-ttf"));
            $('#lsd-font-input').css("font-family", $(this).attr("data-fontname"));

            fontList.addClass('hidden');
            if (lsd.hide_preview === 'yes') {
                setTimeout(function () {
                    $("#lsd-admin-debug").html("");
                    lsd_retrieve_built_image();
                }, 100);
            }
        });


        //call the function if any update on the interface occurs
        $(document).on("click", "#lsd-update-preview", function () {
            $("#lsd-admin-debug").html("");
            lsd_retrieve_built_image();
        });

        /*
         * Handle text alignement
         */
        //left
        $(document).on("click", ".ti-align-left", function () {
            $('#lsd-text-alignment').attr("data-alignment", "left");
            //#000000
            $('.ti-align-left').css('color', '#000000');
            $('.ti-align-right').css('color', '#999');
            $('.ti-align-center').css('color', '#999');
            if (lsd.hide_preview === 'yes') {
                setTimeout(function () {
                    $("#lsd-admin-debug").html("");
                    lsd_retrieve_built_image();
                }, 10);
            }
        });

        //right
        $(document).on("click", ".ti-align-right", function () {
            $('#lsd-text-alignment').attr("data-alignment", "right");
            $('.ti-align-left').css('color', '#999');
            $('.ti-align-right').css('color', '#000000');
            $('.ti-align-center').css('color', '#999');
            if (lsd.hide_preview === 'yes') {
                setTimeout(function () {
                    $("#lsd-admin-debug").html("");
                    lsd_retrieve_built_image();
                }, 10);
            }
        });

        //center
        $(document).on("click", ".ti-align-center", function () {
            $('#lsd-text-alignment').attr("data-alignment", "center");
            $('.ti-align-left').css('color', '#999');
            $('.ti-align-right').css('color', '#999');
            $('.ti-align-center').css('color', '#000000');
            if (lsd.hide_preview === 'yes') {
                setTimeout(function () {
                    $("#lsd-admin-debug").html("");
                    lsd_retrieve_built_image();
                }, 10);
            }
        });

        //Handle text styles
        $(document).on("click", ".lsd-regular", function () {
            $('#lsd-text-style').attr("data-style", "regular");
            $('.lsd-regular').css('color', '#000000');
            $('.lsd-bold').css('color', '#999');
            $('.lsd-italic').css('color', '#999');
            $('.lsd-both').css('color', '#999');
            if (lsd.hide_preview === 'yes') {
                setTimeout(function () {
                    $("#lsd-admin-debug").html("");
                    lsd_retrieve_built_image();
                }, 10);
            }
        });
        
        $(document).on("click", ".lsd-bold", function () {
            $('#lsd-text-style').attr("data-style", "bold");
            $('.lsd-regular').css('color', '#999');
            $('.lsd-bold').css('color', '#000000');
            $('.lsd-italic').css('color', '#999');
            $('.lsd-both').css('color', '#999');
            if (lsd.hide_preview === 'yes') {
                setTimeout(function () {
                    $("#lsd-admin-debug").html("");
                    lsd_retrieve_built_image();
                }, 10);
            }
        });

        $(document).on("click", ".lsd-italic", function () {
            $('#lsd-text-style').attr("data-style", "italic");
            $('.lsd-regular').css('color', '#999');
            $('.lsd-bold').css('color', '#999');
            $('.lsd-italic').css('color', '#000000');
            $('.lsd-both').css('color', '#999');
            if (lsd.hide_preview === 'yes') {
                setTimeout(function () {
                    $("#lsd-admin-debug").html("");
                    lsd_retrieve_built_image();
                }, 10);
            }
        });

        $(document).on("click", ".lsd-both", function () {
            $('#lsd-text-style').attr("data-style", "both");
            $('.lsd-regular').css('color', '#999');
            $('.lsd-bold').css('color', '#999');
            $('.lsd-italic').css('color', '#999');
            $('.lsd-both').css('color', '#000000');
            if (lsd.hide_preview === 'yes') {
                setTimeout(function () {
                    $("#lsd-admin-debug").html("");
                    lsd_retrieve_built_image();
                }, 10);
            }
        });



        $(document).on('click', '.lsd-quantity-container span', function (e) {
            e.preventDefault();
            // Get values
            var $qty = $(".lsd-quantity-field");
            var currentVal = parseFloat($qty.val());
            var max = parseFloat($qty.attr('max'));
            var min = parseFloat($qty.attr('min'));
            var step = $qty.attr('step');
            // Format values
            if (!currentVal || currentVal === '' || currentVal === 'NaN')
                currentVal = 0;
            if (max === '' || max === 'NaN')
                max = '';
            if (min === '' || min === 'NaN')
                min = 0;
            if (step === 'any' || step === '' || step === undefined || parseFloat(step) === 'NaN')
                step = 1;
            // Change the value
            if ($(this).is('.lsd-qty-plus')) {

                if (max && (max === currentVal || currentVal > max)) {
                    $qty.val(max);
                } else {
                    $qty.val(currentVal + parseFloat(step));
                }

            } else {

                if (min && (min === currentVal || currentVal < min)) {
                    $qty.val(min);
                } else if (currentVal > 0) {
                    $qty.val(currentVal - parseFloat(step));
                }

            }
            lsd_update_price();
        });

        /**
         * Function lsd_view_preview
         */
        function lsd_view_preview() {
            var data = lsd_retrieve_designer_data();
            var text = $('.lsd-textarea').val();
            var fonts = $('.lsd-font-picker ul li');
            $('#lsd-preview-block-content').html("");
            fonts.each(function (font) {
                if ($(this).text())
                    $('#lsd-preview-block-content').append("<div data-placement='top' data-tooltip-title='" + $(this).attr("data-fontname") + "' data-fontname='" + $(this).attr("data-fontname") + "' data-fonturl='" + $(this).attr("data-fonturl") + "' data-ttf='" + $(this).attr("data-ttf") + "' class='lsd-update-preview-block-content' style=' cursor: pointer; font-family: " + $(this).text() + "; color: " + data['text_color'] + "; '>" + text + "</div>");
            });
        }

        //$("#lsd-preview-block-content").css("display", "none");
        $(document).on("click touchstart", "#lsd-preview-block", function () {
            lsd_view_preview();
            $("#lsd-preview-block-content").show();
        });


        //call the function if any the interface occurs
        $(document).on("click", ".lsd-range-slider__range, .lsd-range-plus, .lsd-range-minus", function () {
            if (lsd.hide_preview === 'yes') {
                $("#lsd-admin-debug").html("");
                lsd_retrieve_built_image();
            }
        });


        $('.lsd-textarea').change(function () {
            lsd_view_preview();
        });
        $(document).on("click", ".lsd-update-preview-block-content", function () {
            $('#lsd-font-input').attr("value", $(this).attr("data-fontname"));
            $('#lsd-font-input').attr("data-fonturl", $(this).attr("data-fonturl"));
            $('#lsd-font-input').attr("data-ttf", $(this).attr("data-ttf"));
            $('#lsd-font-input').css("font-family", $(this).attr("data-fontname"));

            setTimeout(function () {
                $("#close").click();
                $("#lsd-admin-debug").html("");
                lsd_retrieve_built_image();
            }, 300);
        });

    });
    return lsd_editor;
}(jQuery, LSD_EDITOR));
