(function ($) {
    'use strict';
    $(document).ready(function () {
        if (!('ontouchstart' in window))
        {
            $(".lsd-what-is-this").tooltip({
                title: function () {
                    return $(this).attr('data-tooltip-title');
                }
            });
        }
        function lsd_remove_mini_cart_view_design(){
           $('.woocommerce-mini-cart .lsd-view-design,.woocommerce-mini-cart .lsd-modal').remove(); 
        }
        lsd_remove_mini_cart_view_design()
        $(document).on('click','.lsd-view-design', function(e){
            lsd_remove_mini_cart_view_design();
        });
        
        $(".single_variation_wrap").on("show_variation", function (event, variation) {
// Fired when the user selects all the required dropdowns / attributes
// and a final variation is selected / shown
            var variation_id = $("input[name='variation_id']").val();
            if (variation_id)
            {
                $(".lsd-buttons-wrap-variation").hide();
                $(".lsd-buttons-wrap-variation[data-id='" + variation_id + "']").show();
            }
        });
        

        
        
        function get_mobile_view(){
            var windowsize = $(window).width();
            
            if (windowsize < 780) {
               var sliders = $('#lsd-tools-container').bxSlider({
                pagerCustom: '#lsd-header',
                controls: false,
                infiniteLoop: false,
                touchEnabled: false

            });
                
            }
            
            
        }
        get_mobile_view();
        $( window ).resize(function() {
            get_mobile_view();
        });
//        if (window.matchMedia("(min-width: 320px) and (max-width: 780px)").matches) {
//
//            var slider = $('#lsd-tools-container').bxSlider({
//                pagerCustom: '#lsd-header',
//                controls: false,
//                infiniteLoop: false,
//                touchEnabled: false,
//                onSliderLoad: function () {
//                    // $(".VPC_ln_Skin .components-slider").css("visibility", "visible");
//                }
//            });
//        }

        //function to retrieve all data from the designer
        function lsd_retrieve_designer_data() {
            var data = {};
            //retrieve the text in the textarea
            var enteredText = $('.lsd-textarea').val();
            var formattedText = enteredText.replace(/\n/g, '<br/>');
            data["text"] = formattedText;

            //retrieve the selected font
            var font = $('#lsd-font-input').val();
            data["font"] = font;

            //retrieve the selected font url
            var fonturl = $('#lsd-font-input').attr('data-fonturl');
            data["font-url"] = fonturl;

            //retrieve the selected font ttf
            data["font-ttf"] = $('#lsd-font-input').attr('data-ttf');

            var canvas_w = $('#canvas-custom-width').val();
            var canvas_h = $('#canvas-custom-height').val();

            //data['width'] = $("#lsd-editing-area").width();
            //data['height'] = Math.round((canvas_h * data['width']) / canvas_w);

            data['width'] = canvas_w;
            data['height'] = canvas_h;

            data['custom-width'] = canvas_w;
            data['custom-height'] = canvas_h;

            //retrieve text color
            var text_color = $('#lsd-font-color').attr("data-color");
            data['text_color'] = text_color;

            //retrieve canvas color
            var canvas_color = $('#lsd-canvas-color').attr("data-color");
            if (canvas_color === "") {
                canvas_color = 'transparent';
            }
            data['canvas_color'] = canvas_color;

            //retrieve shadow color
            var shadow_color = $('#lsd-shadow-color').attr("data-color");
            data['shadow_color'] = shadow_color;

            //retrieve outline color
            var outline_color = $('#lsd-outline-color').attr("data-color");
            data['outline_color'] = outline_color;

            data['unit'] = lsd.canvas_dimensions_unit;

            //verify if reverse is checked
            if ($('#lsd-reverse-cut').prop('checked')) {
                data['reverse'] = "true";
            } else {
                data['reverse'] = "false";
            }

            //data['ratio'] = lsd.keep_ratio;

            //alignment
            data['alignment'] = $('#lsd-text-alignment').attr("data-alignment");

            //style
            data['style'] = $('#lsd-text-style').attr("data-style");

            //letter spacing
            data['spacing'] = $("#lsd-spacing-range").val();

            //verify if curved is checked
//            if ($('#lsd-enable-curving').prop('checked')) {
//                data['enable-curving'] = "true";
//            } else {
//                data['enable-curving'] = "false";
//            }

            //text curving
            //data['curving'] = $("#lsd-curving-range").val();

            //text shadow
            data['shadow'] = $("#lsd-shadow-range").val();


            //text outline
            data['outline'] = $("#lsd-outline-range").val();

            //chosen font size
            data['font-size'] = $("#lsd-font-size").val();

            data['dimensions-type'] = lsd.dimensions_type;

            return data;
        }


        //add design to cart
        $("#lsd-add-to-cart").on("click", function () {
            $.blockUI({message: lsd.translated_strings.loading_msg});
            var quantity = $(".lsd-quantity-field").val();
            var frm_data = lsd_retrieve_designer_data();
            var product_id = $(this).attr("data-id");
            if (typeof tpl === 'undefined') {
                var tpl = "";
            }
            //frm_data["output"] = lsd.output;
            frm_data["tpl"] = tpl;
            frm_data["product_id"] = product_id;
            frm_data["quantity"] = quantity;
            var lsd_generate_design_nonce = $('#lsd_generate_design_nonce').val();
            $.post(
                    lsd_ajax_object.lsd_ajax_url,
                    {
                        action: "lsd_add_custom_design_to_cart",
                        data: frm_data,
                        lsd_generate_design_nonce: lsd_generate_design_nonce
                    },function (answer) {
                        var response = JSON.parse(answer);
                        $("#lsd-debug").html(response.message);
                        $.unblockUI();
                        if(lsd.redirect_after === "1"){
                            window.location.href = response.url;
                        }
                    })
                    .fail(function (response) {
                            console.log(response);
                            $("#lsd-admin-debug").html("");
                            $("#lsd-admin-debug").append('the process has failed, please retry it.');
                            $.unblockUI();
                        });
        });
        
        //range slider value
        var rangeSlider = function(){
            var slider = $('.lsd-range-slider-container'),
                range = $('.lsd-range-slider__range'),
                value = $('.lsd-range-slider-value');

            slider.each(function(){

              value.each(function(){
                var value = $(this).prev().attr('value');
                $(this).html(value);
              });

              range.on('input', function(){
                $(this).next(value).html(this.value);
              });
            });
        };
        rangeSlider();
        
        $(document).on('touchstart click', '.lsd-range-slider-container .lsd-range-minus', function () {
            var recup_val = $(this).parents(".lsd-range-slider").find(".lsd-range-slider__range").val();
            var recup_min = $(this).parents(".lsd-range-slider").find(".lsd-range-slider__range").attr('min');
            var recup_step = $(this).parents(".lsd-range-slider").find(".lsd-range-slider__range").attr('step');
            var new_val= parseInt(recup_val) - parseInt(recup_step);
            if(new_val >= recup_min){
                
                $(this).parents(".lsd-range-slider").find(".lsd-range-slider__range").val(new_val);
                $(this).parents(".lsd-range-slider").find(".lsd-range-slider-value").html(new_val);
            }
            $(this).parent('.lsd-range-slider').find('input.lsd-range-slider__range').trigger('change');
        });
        
        $(document).on('touchstart click', '.lsd-range-slider-container .lsd-range-plus', function () {
            var recup_val = $(this).parents(".lsd-range-slider").find(".lsd-range-slider__range").val();
            var recup_max = $(this).parents(".lsd-range-slider").find(".lsd-range-slider__range").attr('max');
            var recup_step = $(this).parents(".lsd-range-slider").find(".lsd-range-slider__range").attr('step');
            var new_val= parseInt(recup_val) + parseInt(recup_step);
            if(new_val <= recup_max){
                
                $(this).parents(".lsd-range-slider").find(".lsd-range-slider__range").val(new_val);
                $(this).parents(".lsd-range-slider").find(".lsd-range-slider-value").html(new_val);
            }
            $(this).parent('.lsd-range-slider').find('input.lsd-range-slider__range').trigger('change');
        });
        
        $(document).on('click touchstart', function () {
            $('.lsd-tools-container').hide();
        });
        $(document).on('click','.lsd-dropdown', function(){
            $('.lsd-tools-container').hide();
            $(this).parents('.lsd-hidden-tools').find('.lsd-tools-container').toggle();
            return false;
        });
        $(document).on("click touchstart", ".lsd-tools-container", function (event) {
            event.stopPropagation();
            
        });
        
        
    });
})(jQuery);
